---
title: DocumentFragment.querySelectorAll()
slug: Web/API/DocumentFragment/querySelectorAll
tags:
  - API
  - DOM
  - DocumentFragment
  - Method
---
<div>{{ApiRef("DOM")}}</div>

<p>The <strong><code>DocumentFragment.querySelectorAll()</code></strong> method returns a {{domxref("NodeList")}} of elements within the {{domxref("DocumentFragment")}} (using depth-first pre-order traversal of the document's nodes) that matches the specified group of selectors.</p>

<p>If the selectors specified in parameter are invalid a {{domxref("DOMException")}} with a <code>SYNTAX_ERR</code> value is raised.</p>

<div class="note">
<p><strong>Note:</strong> The definition of this API was moved to the {{domxref("ParentNode")}} interface.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>elementList</em> = <em>documentfragment</em>.querySelectorAll(<em>selectors</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em>selectors</em></dt>
 <dd>Is a {{domxref("DOMString")}} containing one or more CSS selectors separated by commas.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>This example returns a list of all <code>div</code> elements within the <code>DocumentFragment</code> with a class of either "<code>note</code>" or "<code>alert</code>":</p>

<pre class="brush: js">var matches = documentfrag.querySelectorAll("div.note, div.alert");
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Selectors API Level 1', '#queryselector', 'DocumentFragment.querySelectorAll')}}</td>
   <td>{{Spec2('Selectors API Level 1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DocumentFragment.querySelectorAll")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{domxref("DocumentFragment")}} interface it belongs to.</li>
</ul>
